import { AggFC, DataSource, Fields, CubeProps } from "../types";
declare class Node<Row> {
    children: Map<string, Node<Row>>;
    rawData: DataSource<Row>;
    _aggData: Row;
    constructor();
    push(...params: Array<Row>): void;
    aggData(aggFunc: AggFC<Row>, measures?: any[]): Row;
}
declare class momentCube<Row> {
    private aggFunc;
    private factTable;
    private dimensions;
    private measures;
    tree: Node<Row>;
    constructor(props: CubeProps<Row>);
    get(dimensions: Fields): Row | false;
    setData(props: CubeProps<Row>): void;
    buildTree(): Node<Row>;
    insertNode(record: Row, node: Node<Row>, level: number): void;
    aggTree(node?: Node<Row>): Node<Row>;
}
export default momentCube;
