"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var Node = /** @class */ (function () {
    function Node() {
        this.children = new Map();
        this.rawData = [];
    }
    Node.prototype.push = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        (_a = this.rawData).push.apply(_a, __spread(params));
    };
    Node.prototype.aggData = function (aggFunc, measures) {
        if (measures === void 0) { measures = []; }
        this._aggData = aggFunc(this.rawData, measures);
        return this._aggData;
    };
    return Node;
}());
var momentCube = /** @class */ (function () {
    function momentCube(props) {
        this.aggFunc = props.aggFunc;
        this.factTable = props.factTable;
        this.dimensions = props.dimensions;
        this.measures = props.measures;
        this.buildTree();
        this.aggTree();
    }
    momentCube.prototype.get = function (dimensions) {
        var _a = this, tree = _a.tree, aggFunc = _a.aggFunc, measures = _a.measures;
        var search = function (node, level) {
            var e_1, _a;
            if (level === dimensions.length) {
                return node.aggData(aggFunc, measures);
            }
            var children = node.children.entries();
            try {
                for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                    var _b = __read(children_1_1.value, 2), childName = _b[0], child = _b[1];
                    if (childName === dimensions[level]) {
                        return search(child, level + 1);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        return search(tree, 0);
    };
    momentCube.prototype.setData = function (props) {
        var _a = props.aggFunc, aggFunc = _a === void 0 ? this.aggFunc : _a, _b = props.factTable, factTable = _b === void 0 ? this.factTable : _b, _c = props.dimensions, dimensions = _c === void 0 ? this.dimensions : _c, _d = props.measures, measures = _d === void 0 ? this.measures : _d;
        if (dimensions !== this.dimensions || factTable !== this.factTable) {
            this.dimensions = dimensions;
            this.factTable = factTable;
            this.measures = measures;
            this.aggFunc = aggFunc;
            this.buildTree();
            this.aggTree();
        }
        else if (measures !== this.measures || aggFunc !== this.aggFunc) {
            this.measures = measures;
            this.aggFunc = aggFunc;
            this.aggTree();
        }
    };
    momentCube.prototype.buildTree = function () {
        var tree = new Node();
        var len = this.factTable.length, i;
        for (i = 0; i < len; i++) {
            this.insertNode(this.factTable[i], tree, 0);
        }
        this.tree = tree;
        return tree;
    };
    momentCube.prototype.insertNode = function (record, node, level) {
        if (level === this.dimensions.length) {
            node.push(record);
        }
        else {
            var member = record[this.dimensions[level]];
            if (!node.children.has(member)) {
                node.children.set(member, new Node());
            }
            this.insertNode(record, node.children.get(member), level + 1);
        }
    };
    momentCube.prototype.aggTree = function (node) {
        var e_2, _a;
        if (node === void 0) { node = this.tree; }
        if (node.children.size > 0) {
            node.rawData = [];
            var children = node.children.values();
            try {
                for (var children_2 = __values(children), children_2_1 = children_2.next(); !children_2_1.done; children_2_1 = children_2.next()) {
                    var child = children_2_1.value;
                    var i = void 0;
                    var data = this.aggTree(child).rawData;
                    var len = data.length;
                    for (i = 0; i < len; i++) {
                        node.rawData.push(data[i]);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (children_2_1 && !children_2_1.done && (_a = children_2.return)) _a.call(children_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        node.aggData(this.aggFunc, this.measures);
        return node;
    };
    return momentCube;
}());
exports.default = momentCube;
