"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var Node = /** @class */ (function () {
    function Node(aggFunc) {
        this.children = new Map();
        this._rawData = [];
        this.aggFunc = aggFunc;
        this.cache = false;
    }
    Node.prototype.push = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        (_a = this._rawData).push.apply(_a, __spread(params));
    };
    Node.prototype.aggData = function (measures) {
        if (measures === void 0) { measures = []; }
        if (!this.cache) {
            this._aggData = this.aggFunc(this.rawData, measures);
            this.cache = true;
        }
        return this._aggData;
    };
    Node.prototype.clearCache = function () {
        this.cache = false;
    };
    Object.defineProperty(Node.prototype, "rawData", {
        get: function () {
            var e_1, _a;
            if (!this.cache) {
                if (this.children.size !== 0) {
                    var children = this.children.values();
                    var rawData = [];
                    try {
                        for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                            var child = children_1_1.value;
                            var i = void 0;
                            var data = child.rawData;
                            var len = data.length;
                            for (i = 0; i < len; i++) {
                                rawData.push(data[i]);
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    this._rawData = rawData;
                }
                this.cache = true;
            }
            return this._rawData;
        },
        enumerable: true,
        configurable: true
    });
    return Node;
}());
var periodCube = /** @class */ (function () {
    function periodCube(props) {
        this.aggFunc = props.aggFunc;
        this.factTable = props.factTable;
        this.dimensions = props.dimensions;
        this.measures = props.measures;
    }
    periodCube.prototype.get = function (dimensions) {
        var _a = this, tree = _a.tree, aggFunc = _a.aggFunc, measures = _a.measures;
        var search = function (node, level) {
            var e_2, _a;
            if (level === dimensions.length) {
                return node.aggData(measures);
            }
            var children = node.children.entries();
            try {
                for (var children_2 = __values(children), children_2_1 = children_2.next(); !children_2_1.done; children_2_1 = children_2.next()) {
                    var _b = __read(children_2_1.value, 2), childName = _b[0], child = _b[1];
                    if (childName === dimensions[level]) {
                        return search(child, level + 1);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (children_2_1 && !children_2_1.done && (_a = children_2.return)) _a.call(children_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return false;
        };
        return search(tree, 0);
    };
    periodCube.prototype.buildTree = function () {
        var tree = new Node(this.aggFunc);
        var len = this.factTable.length, i;
        for (i = 0; i < len; i++) {
            this.insertNode(this.factTable[i], tree, 0);
        }
        this.tree = tree;
        return tree;
    };
    periodCube.prototype.insertNode = function (record, node, level) {
        node.push(record);
        node.cache = false;
        if (level < this.dimensions.length) {
            var member = record[this.dimensions[level]];
            if (!node.children.has(member)) {
                node.children.set(member, new Node(this.aggFunc));
            }
            this.insertNode(record, node.children.get(member), level + 1);
        }
    };
    periodCube.prototype.aggTree = function (node) {
        var e_3, _a;
        if (node === void 0) { node = this.tree; }
        var children = node.children.values();
        try {
            for (var children_3 = __values(children), children_3_1 = children_3.next(); !children_3_1.done; children_3_1 = children_3.next()) {
                var child = children_3_1.value;
                this.aggTree(child);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (children_3_1 && !children_3_1.done && (_a = children_3.return)) _a.call(children_3);
            }
            finally { if (e_3) throw e_3.error; }
        }
        node.aggData(this.measures);
        return node;
    };
    periodCube.prototype.aggNode = function (node) {
        var e_4, _a;
        if (node === void 0) { node = this.tree; }
        var children = node.children.values();
        try {
            for (var children_4 = __values(children), children_4_1 = children_4.next(); !children_4_1.done; children_4_1 = children_4.next()) {
                var child = children_4_1.value;
                this.aggTree(child);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (children_4_1 && !children_4_1.done && (_a = children_4.return)) _a.call(children_4);
            }
            finally { if (e_4) throw e_4.error; }
        }
        node.aggData(this.measures);
        return node;
    };
    return periodCube;
}());
exports.default = periodCube;
