"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./core/index");
var aggregation_1 = require("./utils/aggregation");
function createCube(_a) {
    var type = _a.type, _b = _a.aggFunc, aggFunc = _b === void 0 ? aggregation_1.count : _b, _c = _a.factTable, factTable = _c === void 0 ? [] : _c, _d = _a.dimensions, dimensions = _d === void 0 ? [] : _d, _e = _a.measures, measures = _e === void 0 ? [] : _e;
    switch (type) {
        case "period":
            return new index_1.periodCube({
                aggFunc: aggFunc,
                factTable: factTable,
                dimensions: dimensions,
                measures: measures
            });
        case "moment":
            return new index_1.momentCube({
                aggFunc: aggFunc,
                factTable: factTable,
                dimensions: dimensions,
                measures: measures
            });
        default:
            return new index_1.momentCube({
                aggFunc: aggFunc,
                factTable: factTable,
                dimensions: dimensions,
                measures: measures
            });
    }
}
exports.createCube = createCube;
__export(require("./utils/aggregation"));
